Imports System
Imports System.Query
Imports System.Data
Imports System.Data.SqlClient
Imports System.Xml
Imports System.Xml.XLinq
'Imports System.Text
'Add below to replace List(Of T) with BindingList(Of T)

Public Class Northwind
    Private strConn As String = "Server=localhost;Database=Northwind;Integrated Security=SSPI"
    'Enables compilation of Methods
    Public Customers As List(Of Customer)
    Public Orders As List(Of [Order])
    Public Items As List(Of Item)
    Public Products As List(Of Product)

    Public Sub GetCustomers()
        'Following emulates DataContext to generate up to 91 Northwind Customer entity class instances
        Dim cnNwind As New SqlConnection(strConn)
        Dim cmCusts As New SqlCommand("SELECT * FROM Customers", cnNwind)
        Dim objCust() As Object
        Try
            cnNwind.Open()
            Dim sdrCusts As SqlDataReader = cmCusts.ExecuteReader
            With sdrCusts
                If .HasRows Then
                    ReDim objCust(.FieldCount - 1)
                    Dim objList As Customer
                    Dim intCol As Integer
                    While .Read
                        .GetValues(objCust)
                        objList = New Customer
                        For intCol = 0 To objCust.Length - 1
                            Select Case intCol
                                Case 0
                                    objList.CustomerID = objCust(intCol).ToString
                                Case 1
                                    objList.CompanyName = objCust(intCol).ToString
                                Case 2
                                    objList.ContactName = objCust(intCol).ToString
                                Case 3
                                    objList.ContactTitle = objCust(intCol).ToString
                                Case 4
                                    objList.Address = objCust(intCol).ToString
                                Case 5
                                    objList.City = objCust(intCol).ToString
                                Case 6
                                    objList.Region = objCust(intCol).ToString
                                Case 7
                                    objList.PostalCode = objCust(intCol).ToString
                                Case 8
                                    objList.Country = objCust(intCol).ToString
                                Case 9
                                    objList.Phone = objCust(intCol).ToString
                                Case 10
                                    objList.Fax = objCust(intCol).ToString
                            End Select
                        Next intCol
                        Customers.Add(objList)
                    End While
                End If
                .Close()
            End With
            'Dim intCount As Integer = Customers.Count
        Catch exc As Exception
            MsgBox(exc.Message)
        Finally
            cnNwind.Close()
            cnNwind.Dispose()
            cmCusts.Dispose()
        End Try
    End Sub

    Public Sub GetOrders()
        'Following emulates DataContext to generate up to 830 Northwind Order entity class instances
        Dim cnNwind As New SqlConnection(strConn)
        Dim cmOrders As New SqlCommand("SELECT OrderID, CustomerID, EmployeeID, OrderDate, RequiredDate, ShippedDate, ShipVia, Freight, ShipCountry FROM Orders", cnNwind)
        Dim objOrder() As Object
        Try
            cnNwind.Open()
            Dim sdrOrders As SqlDataReader = cmOrders.ExecuteReader
            With sdrOrders
                If .HasRows Then
                    ReDim objOrder(.FieldCount - 1)
                    Dim objList As [Order]
                    Dim intCol As Integer
                    While .Read
                        .GetValues(objOrder)
                        objList = New [Order]
                        For intCol = 0 To objOrder.Length - 1
                            Select Case intCol
                                Case 0
                                    objList.OrderID = CType(objOrder(intCol), Integer)
                                Case 1
                                    objList.CustomerID = objOrder(intCol).ToString
                                Case 2
                                    objList.EmployeeID = CType(objOrder(intCol), Integer)
                                Case 3
                                    objList.OrderDate = CType(objOrder(intCol), Date)
                                Case 4
                                    objList.RequiredDate = CType(objOrder(intCol), Date)
                                Case 5
                                    If IsDBNull(objOrder(intCol)) Then
                                        objList.ShippedDate = Nothing
                                    Else
                                        objList.ShippedDate = CType(objOrder(intCol), Date)
                                    End If
                                Case 6
                                    objList.ShipVia = CType(objOrder(intCol), Integer)
                                Case 7
                                    objList.Freight = CType(objOrder(intCol), Decimal)
                                Case 8
                                    objList.ShipCountry = objOrder(intCol).ToString
                            End Select
                        Next intCol
                        Orders.Add(objList)
                    End While
                End If
                .Close()
            End With
            'Dim intCount As Integer = Orders.Count
        Catch exc As Exception
            MsgBox(exc.Message)
        Finally
            cnNwind.Close()
            cnNwind.Dispose()
            cmOrders.Dispose()
        End Try
    End Sub

    Public Sub GetItems()
        'Following emulates DataContext to generate 2155 Northwind Item entity class instances
        Dim cnNwind As New SqlConnection(strConn)
        Dim cmOrders As New SqlCommand("SELECT * FROM [Order Items]", cnNwind)
        Dim objItem() As Object
        Try
            cnNwind.Open()
            Dim sdrItems As SqlDataReader = cmOrders.ExecuteReader
            With sdrItems
                If .HasRows Then
                    ReDim objItem(.FieldCount - 1)
                    Dim objList As Item
                    Dim intCol As Integer
                    While .Read
                        .GetValues(objItem)
                        objList = New Item
                        For intCol = 0 To objItem.Length - 1
                            Select Case intCol
                                Case 0
                                    objList.OrderID = CType(objItem(intCol), Integer)
                                Case 1
                                    objList.OrderID = CType(objItem(intCol), Integer)
                                Case 2
                                    objList.OrderID = CType(objItem(intCol), Decimal)
                                Case 3
                                    objList.OrderID = CType(objItem(intCol), Short)
                                Case 4
                                    objList.OrderID = CType(objItem(intCol), Decimal)
                            End Select
                        Next intCol
                        Items.Add(objList)
                    End While
                End If
                .Close()
            End With
            'Dim intCount As Integer = Items.Count
        Catch exc As Exception
            MsgBox(exc.Message)
        Finally
            cnNwind.Close()
            cnNwind.Dispose()
            cmOrders.Dispose()
        End Try
    End Sub

    Public Sub GetProducts()
        'Following emulates DataContext to generate up to 77 Northwind Product entity class instances
        Dim cnNwind As New SqlConnection(strConn)
        Dim cmProds As New SqlCommand("SELECT * FROM Products", cnNwind)
        Dim objProd() As Object
        Try
            cnNwind.Open()
            Dim sdrProds As SqlDataReader = cmProds.ExecuteReader
            With sdrProds
                If .HasRows Then
                    ReDim objProd(.FieldCount - 1)
                    Dim objList As Product
                    Dim intCol As Integer
                    While .Read
                        .GetValues(objProd)
                        objList = New Product
                        For intCol = 0 To objProd.Length - 1
                            Select Case intCol
                                Case 0
                                    objList.ProductID = CType(objProd(intCol), Integer)
                                Case 1
                                    objList.ProductName = objProd(intCol).ToString
                                Case 2
                                    objList.SupplierID = CType(objProd(intCol), Integer)
                                Case 3
                                    objList.CategoryID = CType(objProd(intCol), Integer)
                                Case 4
                                    objList.QuantityPerUnit = objProd(intCol).ToString
                                Case 5
                                    objList.UnitPrice = CType(objProd(intCol), Decimal)
                                Case 6
                                    objList.UnitsInStock = CType(objProd(intCol), Short)
                                Case 7
                                    objList.UnitsOnOrder = CType(objProd(intCol), Short)
                                Case 8
                                    objList.ReorderLevel = CType(objProd(intCol), Short)
                                Case 9
                                    objList.Discontinued = CType(objProd(intCol), Boolean)
                            End Select
                        Next intCol
                        Products.Add(objList)
                    End While
                End If
                .Close()
            End With
            'Dim intCount As Integer = Products.Count
        Catch exc As Exception
            MsgBox(exc.Message)
        Finally
            cnNwind.Close()
            cnNwind.Dispose()
            cmProds.Dispose()
        End Try
    End Sub

    Public Class Customer
        'Northwind Customer(s) entity class
        Public CustomerID As String
        Public CompanyName As String
        Public ContactName As String
        Public ContactTitle As String
        Public Address As String
        Public City As String
        Public Region As String
        Public PostalCode As String
        Public Country As String
        Public Phone As String
        Public Fax As String
    End Class

    Public Class [Order]
        'Northwind Order(s) entity class
        Public OrderID As Integer
        Public CustomerID As String
        Public EmployeeID As Integer
        Public OrderDate As Date
        Public RequiredDate As Nullable(Of Date)
        Public ShippedDate As Nullable(Of Date)
        Public ShipVia As Integer
        Public Freight As Nullable(Of Decimal)
        Public ShipCountry As String
    End Class

    Public Class Item
        'Northwind Order Details(s) entity class renamed
        Public OrderID As Integer
        Public ProductID As Integer
        Public UnitPrice As Decimal
        Public Quantity As Short
        Public discount As Decimal
    End Class

    Public Class Product
        'Northwind Product(s) entity class
        Public ProductID As Integer
        Public ProductName As String
        Public SupplierID As Integer
        Public CategoryID As Integer
        Public QuantityPerUnit As String
        Public UnitPrice As Decimal
        Public UnitsInStock As Short
        Public UnitsOnOrder As Short
        Public ReorderLevel As Short
        Public Discontinued As Boolean
    End Class
End Class
